/* input.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <conio.h>
#include <ctype.h>
#include <sys/winmgr.h>
#include <sys/video.h>
#include <sys/kbdscan.h>
#include "global.h"
#include "edits.h"

#define INSERT 1
#define OVERWRT 2
  
struct sum
{
  char *line;
  int number;
  struct sum *prev;
  struct sum *next;
};

extern int idx_file;
extern int date_file;
void get_summary (char temp[600]);
int right (char *line, int pos); /* Rechtsverschiebung eines String, Rckgabe des bertrags */
struct sum *ins_line (struct sum *root, int y, int *last_y);
struct sum *del_char (struct sum *root, wm_handle win, int x, int y, int *last_x, int *last_y);
struct sum *append_line (struct sum *root, int y, int *last_x, int *last_y, int over); /* Rckgabe angef. Z. */
int check_last (struct sum *root, int x, int y); /* checkt, ob letzte pos nicht bersprungen wird */
struct sum *del_line (struct sum *root, int y, int *last_x, int *last_y);

void input (char str[200])
{

  char issue[7];
  int page;
  char *author;
  char *title;
  char *keywords;
  char *summary;
  char *temp;
  int repeat = 1;
  int ok;
  struct index index;

  temp = (char *)malloc (601);
  v_gotoxy (0,0);
  
  while (repeat != 'n')
    {
      v_printf ("\n");
      strcpy (temp,"issue:  ");
      temp = v_edits (temp, 7, 8);
      strcpy (issue, temp);
      v_printf ("\n");

      v_printf ("\n");
      strcpy (temp, "page:  ");
      temp = v_edits (temp, 3, 7);
      page = atoi(temp);
      v_printf ("\n");

      v_printf ("\n");
      strcpy (temp, "author:  ");
      temp = v_edits (temp, 300, 9);
      author = (char *)malloc (strlen(temp)+1);
      strcpy (author, temp);
      v_printf ("\n");

      v_printf ("\n");
      strcpy (temp, "title:  ");
      temp = v_edits (temp, 400, 8);
      title = (char *)malloc (strlen(temp)+1);
      strcpy (title, temp);
      v_printf ("\n");

      v_printf ("\n");
      strcpy (temp, "keywords:  ");
      temp = v_edits (temp, 400, 11);
      keywords = (char *)malloc (strlen (temp)+1);
      strcpy (keywords, temp);
      v_printf ("\n");

      strcpy (temp,"");
      get_summary (temp);
      v_attrib (F_WHITE|B_BLACK);
      summary = (char *)malloc (strlen (temp)+1);
      strcpy (summary, temp);
      
      strcpy (index.issue, issue);
      index.page = page;
      index.author = strlen(author);
      index.title = strlen (title);
      index.keywords = strlen (keywords);
      index.summary = strlen (summary);

      v_printf ("\n \n Entry ok (J/n) ?");
      ok = getch ();
      if (ok == 0) ok = getch ();

      if ((ok != 'n') && (ok != 'N'))
	{
	  write (idx_file, &index, sizeof (index));
	  write (date_file, author, index.author);
	  write (date_file, title, index.title);
	  write (date_file, keywords, index.keywords);
	  write (date_file, summary, index.summary);
	}
      
      free ((void *)author);
      free ((void *)title);
      free ((void *)keywords);
      free ((void *)summary);

      v_printf ("\n \n Another entry (J/n) ?");
      repeat = getch ();
      if (repeat == 0) repeat = getch ();
      v_printf ("\n");
    }

  free ((void *)temp);

}

void get_summary (char temp[600])
{

  int x,y;
  int xt, yt;
  int last_x, last_y;
  int i,j,k;
  int c;
  int ok;
  int over_cur, over_new;
  int mode;
  char tline[61];
  struct sum *summary;
  struct sum *sum_root;
  
  wm_handle win;
  
  wm_init (1);
  win = wm_create (10,7,69,17,1,F_YELLOW|INTENSITY|B_BLUE,F_YELLOW|INTENSITY|B_BLUE);
  wm_border (win, 1, F_YELLOW|INTENSITY|B_BLUE, "Summary - save with Ctrl-e", 0, F_YELLOW|INTENSITY|B_BLUE);
  wm_open (win);
  wm_cursor (win);

  summary = (struct sum *)malloc (sizeof (struct sum));
  sum_root = summary;
  summary->prev = NULL;
  summary->next = NULL;
  summary->line = NULL;
  summary->number = 0;

  k=0; j=0;			/* j is the line-counter */
  while (temp[k]!=0)
    {
      i=0;
      while ((temp[k]!=0) && (temp[k]!='\n') && (i<60))
	{
	  tline[i]=temp[k];
	  i++;
	  k++;
	}
      if (i==60) {tline[60]='\x0'; last_x=60;}
      else
	if (temp[k]=='\n') {tline[i]='\n'; k++; i++; tline[i]='\x0'; last_x = i-1;}
      else
	if (temp[k]==0) {tline[i]='\x0'; last_x = i;}

      summary->line = (char *)malloc (61);
      strcpy (summary->line, tline);
      summary->number=j;
      last_y = j;
      summary->next= (struct sum *)malloc (sizeof (struct sum));
      summary->next->prev = summary;
      summary = summary->next;
      summary->next = NULL;
      j++; 
      summary->number = j;
      summary->line = NULL;
    }

  if (sum_root->line != NULL)
    {
      strcpy (tline, summary->prev->line);
      if (tline[strlen(tline)-1] == '\n') tline[strlen(tline)-1] = '\x0';
      strcpy (summary->prev->line, tline);
      summary = sum_root;
      
      while (summary->next != NULL)  
	{
	  wm_printf (win, "%s", summary->line);
	  summary = summary->next;
	}
      
      wm_gotoxy (win, last_x, last_y);
    }
  else
    {
      wm_gotoxy (win, 0, 0);
      last_x = 0;
      last_y = 0;
      summary->line = (char *)malloc (61);
      summary->line[0]='\x0';
      summary->next = (struct sum *)malloc (sizeof (struct sum));
      summary->next->prev = summary;
      summary->next->line = NULL;
      summary->next->next = NULL;
      summary->next->number = 1;
    }

  mode = INSERT;
  c = 0;
  
  while (c != 5) 
    {
      c = getch ();
      if (c==0) {c=getch (); c+=256;}
      
      switch (c)
	{
	case 5:
	  break;

	case K_INS+256:
	  if (mode==INSERT)
	    {
	      mode=OVERWRT;
	      wm_ctype (win, 0, 14);
	    }
	  else
	    {
	      mode=INSERT;
	      wm_ctype (win, 13, 14);
	    }
	  break;
	  
	case K_RIGHT+256:
	  wm_getxy (win, &x, &y);
	  if (!((x==last_x) && (y==last_y)))
	    {
	      summary=sum_root;
	      for (i=0; i<y; i++)
		summary=summary->next;
	      k = strlen (summary->line);
	      if ((x==k-1) || ((x==59) && (k==60)))
		{
		  if ((y==last_y) && (x==k-1)) x++;
		  else {y++; x=0;}
		  wm_gotoxy (win, x, y);
		}
	      else
		{
		  x++;
		  wm_gotoxy (win, x, y);
		}
	    }
	  break;
	  	  
	case K_LEFT+256:
	  wm_getxy (win, &x, &y);
	  if (!((y==0) && (x==0)))
	    {
	      if (x>0)
		{
		  x--;
		  wm_gotoxy (win, x, y);
		}
	      else
		{
		  y--;
		  summary=sum_root;
		  for (i=0; i<y; i++)
		    summary = summary->next;
		  k = strlen (summary->line);
		  x=k-1;
 		  if (x==60) x--; 
		  wm_gotoxy (win, x, y);
		}
	    }
	  break;
	  
	case K_UP+256:
	  wm_getxy (win, &x, &y);
	  if (y>0)
	    {
	      y--;
	      summary = sum_root;
	      for (i=0; i<y; i++)
		summary = summary->next;
	      k = strlen (summary->line);
	      if (k-1<x) x=k-1;
	      wm_gotoxy (win, x, y);
	    }
	  break;

	case K_DOWN+256:
	  wm_getxy (win, &x, &y);
	  if (y<last_y)
	    {
	      y++;
	      summary = sum_root;
	      for (i=0; i<y; i++)
		summary = summary->next;
	      k = strlen (summary->line);
	      if ((k-1<x)  && (y==last_y)) x=k;
	      else if (k-1<x) x=k-1;
	      wm_gotoxy (win, x, y);
	    }
	  break;

	case K_DEL+256:		/* delete gedrckt */
	  wm_getxy (win, &x, &y);
	  if (!((x==last_x) && (y==last_y)))
	    {
	      summary = sum_root;
	      for (i=0; i<y; i++)
		summary = summary->next;
	      if (summary->line[x] == '\n')
		{
		  for (i=x; i<=59; i++)
		    summary->line[i]=32;
		  summary->line[60]='\x0';
		  for (i=x; i<=59; i++)
		    del_char (sum_root, win, x, y, &last_x, &last_y);
		}
	      else
		summary = del_char (sum_root, win, x, y, &last_x, &last_y);
	    }
	  wm_gotoxy (win, x, y);
	  
	  break;

	case 8:			/* Backspace gedrckt */
	  wm_getxy (win, &x, &y);
	  yt = y;
	  if (!((x==0) && (y==0)))
	    {
	      summary = sum_root;
	      for (i=0; i<y; i++)
		summary = summary->next;
	      if (x==0)
		{
		  y--;
		  x = strlen (summary->prev->line)-1;
		}
	      else x--;
	      
	      if (((y!=yt)&&(summary->prev->line[x]=='\n')) || ((y==yt)&&(summary->line[x]=='\n')))
		{
		  for (i=x; i<=59; i++)
		    summary->prev->line[i]=32;
		  summary->prev->line[60]='\x0';
		  for (i=x; i<=59; i++)
		    del_char (sum_root, win, x, y, &last_x, &last_y);
		}
	      else
		summary = del_char (sum_root, win, x, y, &last_x, &last_y);
	    }
	  
	  wm_gotoxy (win, x, y);
	  break;

	case 13:		/* Wenn ENTER gedrckt */
	  if (last_y < 9)	/* nur wenn Zeile frei */
	    {
	      wm_getxy (win, &x, &y);
	      summary = sum_root;
	      for (i=0; i<y; i++)
		summary = summary->next;
	      if (summary->number == last_y) /* letzte Zeile */
		{
		  summary = append_line (sum_root, y, &last_x, &last_y, 0);
		  for (i=x; i<=60; i++)
		    summary->line[i-x] = summary->prev->line[i];
		  k = strlen(summary->line);
		  if (k>0) last_x= k-1; else last_x = 0;
		  summary->prev->line[x]='\n';
		  summary->prev->line[x+1]='\x0';
		  wm_gotoxy (win, 0, y+1);
		  wm_printf (win, "%s", summary->line);
		  wm_clr_eol (win, x, y);
		  wm_gotoxy (win, 0, y+1);
		}
	      else		/* mitten im Text */
		{
		  summary = ins_line (sum_root, y, &last_y);
		  for (i=x; i<=60; i++)
		    summary->line[i-x]=summary->prev->line[i];
		  summary->prev->line[x]='\n';
		  summary->prev->line[x+1]='\x0';
		  wm_clr_eol (win, x, y);
		  wm_ins_line (win, y+1, 1);
		  wm_gotoxy (win, 0, summary->number);
		  wm_printf (win, "%s", summary->line);
		  wm_gotoxy (win, 0, y+1);
		}
	      summary = sum_root; /* reparieren, wenn Nullzeichen mitten im Text */
	      for (i=0; i<y+1; i++)
		summary = summary->next;
	      k = strlen(summary->line);
	      if (k>0) k--;
	      if ((summary->line[k] != '\n') && (summary->number < last_y))
		{
		  for (i=k+1; i<=59; i++)
		    summary->line[i]=32;
		  summary->line[60]='\x0';
		  for (i=k+1; i<=59; i++)
		    del_char (sum_root, win, k+1, summary->number, &last_x, &last_y);
		  wm_gotoxy (win, 0, y+1);
		}
	    } /* end ENTER */
	  
	  break;
	  
	default:
	  if (c>31)
	    {
	      wm_getxy (win, &x, &y);
	      ok = check_last (sum_root, x, y); /* wird last_pos nicht bersprungen */
	      if (ok)
		{
		  summary=sum_root;
		  for (i=0; i<y; i++)
		    summary = summary->next;
		  if ((summary->line[x]=='\n') || (summary->line[x]=='\x0') || (mode==INSERT)) 
		    {		/* INSERT-Modus */
		      if (!((x==last_x) && (y==last_y))) 
			{	/* wenn nicht letzte Position */
			  over_cur = right (summary->line, x);
			  summary->line[x]=c;
			  if (over_cur != 0)
			    {	/* wenn bertrag vorhanden */
			      if (over_cur == '\n') 
				{ /* bei ENTER --> Leerzeile einfgen */
				  summary = ins_line (sum_root, y, &last_y);
				  wm_gotoxy (win, 0, y);
				  wm_printf (win, "%s", summary->prev->line);
				  wm_gotoxy (win, x+1, y);
				  wm_ins_line (win, y+1, 1);
			  			  
				} /* end bei ENTER --> Leerzeile einfgen */
			      else /* sonstige Zeichen --> Zeilen verschieben */
				{
				  xt=x; yt=y;
				  wm_gotoxy (win, 0, y);
				  wm_printf (win, "%s", summary->line);
			  
				  if (y == last_y) /* bei letzter Zeile neue anfgen */
				    {
				      summary = append_line (sum_root, y, &last_x, &last_y, over_cur);
				      wm_gotoxy (win, 0, y+1);
				      wm_printf (win, "%s", summary->line);
				      if (x==59) wm_gotoxy (win, 0, y+1);
				      else wm_gotoxy (win, x+1, y);
			      
				    } /* end neue Zeile anfgen */
				  else /* x,y mitten im Text */
				    {
				      summary = summary->next;
				      k = strlen(summary->line);
				      y++;
				      while ((y<last_y) && (summary->line[k-1]!='\n'))
					{
					  over_new = right (summary->line, 0);
					  summary->line[0]=over_cur;
					  wm_gotoxy (win, 0, y);
					  wm_printf (win, "%s", summary->line);
					  over_cur = over_new;
					  summary = summary->next;
					  y++;
					  k = strlen (summary->line);
					}
			      
				      if (y==last_y)
					{
					  over_new = right (summary->line, 0);
					  summary->line[0]=over_cur;
					  wm_gotoxy (win, 0, y);
					  wm_printf (win, "%s", summary->line);
					  if (over_new == 0)
					    {				  
					      if (xt==59) wm_gotoxy (win, 0, yt+1);
					      else wm_gotoxy (win, xt+1, yt);
					    }
					  else
					    {
					      summary = append_line (sum_root, y, &last_x, &last_y, over_new);
					      wm_gotoxy (win, 0, y+1);
					      wm_printf (win, "%s", summary->line);
					      if (xt==59) wm_gotoxy (win, 0, yt+1);
					      else wm_gotoxy (win, xt+1, yt);
					    }
					  while (summary->next->line != NULL)
					    summary = summary->next;
					  last_x = strlen (summary->line);
					  last_y = summary->number;
					}
				      else
					{
					  if (k==60)
					    {
					      right (summary->line, 0);
					      summary->line[0] = over_cur;
					      wm_gotoxy (win, 0, summary->number);
					      wm_printf (win, "%s", summary->line);
					      summary = ins_line (sum_root, y, &last_y);
					      wm_gotoxy (win, 0, y);
					      wm_printf (win, "%s", summary->prev->line);
					      wm_gotoxy (win, x+1, y);
					      wm_ins_line (win, y+1, 1);
					    }
					  else
					    {
					      right (summary->line, 0);
					      summary->line[0]=over_cur;
					      wm_gotoxy (win, 0, summary->number);
					      wm_printf (win, "%s", summary->line);
					      if (xt==59) wm_gotoxy (win, 0, yt+1);
					      else wm_gotoxy (win, xt+1, yt);
					    }
					}
			      
				    } /* end x,y mitten im Text */
			  			  
				} /* end sonstige Zeichen --> Zeilen verschieben */
			    }
			  else
			    {	/* wenn kein bertrag vorhanden ist */
			      wm_gotoxy (win, 0, y);
			      wm_printf (win, "%s", summary->line);
			      wm_gotoxy (win, x+1, y);
			      if (y==last_y) last_x++;
			    }
			} /* end wenn kein bertrag vorhanden ist */
		      else	/* wenn auf letzter Position */
			{
			  summary->line[x]=c;
			  summary->line[x+1]='\x0';
			  wm_gotoxy (win, 0, y);
			  wm_printf (win, "%s", summary->line);
			  if (x==59)
			    {
			      last_y++; last_x=0;
			      wm_gotoxy (win, last_x, last_y);
			      summary = summary->next; /* neue Zeile anfgen */
			      summary->line = (char *)malloc (61);
			      summary->line[0]='\x0';
			      summary->next = (struct sum *)malloc (sizeof (struct sum));
			      summary->next->number = summary->number+1;
			      summary->next->line = NULL;
			      summary->next->next = NULL;
			      summary->next->prev = summary;
			    }
			  else {last_x++; wm_gotoxy (win, last_x, last_y);}
			} /* end wenn auf letzter Position */
		    } /* end INSERT_Modus */
		  else		/* OVERWRT-Modus */
		    {
		      summary->line[x]=c;
		      wm_putc_at (win, x, y, c);
		      k = strlen (summary->line);
		      if (x<59) x++; else {y++; x=0;}
		      wm_gotoxy (win, x, y);
		    }
		} /* end wenn ok */
	    }
	  break;
	}
    }

  if (sum_root->line != NULL)
    {
      summary = sum_root;
      
      for (i=0; i<=600; i++)
	temp[i]=0;
      
      while (summary->next != NULL)
	{
	  strcat (temp, summary->line);
	  summary = summary->next;
	}
      
      while (summary->next != NULL)
	summary = summary->next;
      
      while (summary->prev != NULL)
	{
	  free ((void *)summary->line);
	  summary = summary->prev;
	  free ((void *)summary->next);
	}
      free ((void *)summary->line);
      free ((void *)summary);
    }
  
  wm_close (win);
  wm_exit ();
}


int right (char *line, int pos)
{
  int over;			/* bertrag */
  char temp[61];
  int length;
  int i;

  length = strlen (line);
  if (length == 60)
    {
      over = line[59];
      temp[60]='\x0';
    }
  else over = 0;

  for (i=0; i<pos; i++)
    temp[i]=line[i];
  for (i=59; i>=pos; i--)
    temp[i]=line[i-1];

  temp[pos]='x';
  temp[60]='\x0';
  
  strcpy (line, temp);
  return (over);
}

struct sum *ins_line (struct sum *root, int y, int *last_y)
{

  int i;
  int l;
  struct sum *temp;

  temp = root;
  for (i=0; i<y; i++)
    temp = temp->next;
  l = temp->number;
  while (temp->number <= (*last_y))
    temp=temp->next;
  (*last_y)++;
  temp->next = (struct sum *)malloc (sizeof (struct sum));
  temp->next->prev = temp;
  temp->next->number = (*last_y)+1;
  temp->next->next=NULL;
  temp->next->line = NULL;
  
  temp->line = (char *)malloc (61);
  strcpy (temp->line, temp->prev->line);
  temp = temp->prev;
  
  while (temp->number > l+1)
    {
      strcpy (temp->line, temp->prev->line);
      temp = temp->prev;
    }
  
  temp->line[0]='\n';
  temp->line[1]='\x0';

  return (temp);
}

struct sum *append_line (struct sum *root, int y, int *last_x, int *last_y, int over)
{
  int i;
  struct sum *temp;

  temp = root;
  for (i=0; i<=y; i++)
    temp = temp->next;

  temp->number = y+1;
  temp->line = (char *)malloc (61);
  temp->line[0]=over;
  temp->line[1]='\x0';
  temp->next = (struct sum *)malloc (sizeof (struct sum));
  temp->next->prev = temp;
  temp->next->next = NULL;
  temp->next->line = NULL;
  temp->next->number = y+2;

  (*last_y)++;
  (*last_x)=1;
  
  return (temp);
}

int check_last (struct sum *root, int x, int y)
{

  int i, k;
  int add = 0;
  struct sum *temp;

  temp = root;
  for (i=0; i<y; i++)
    temp = temp->next;

  k = strlen (temp->line);  
  while ((k == 60) && (temp->next->line != NULL))
    {
      if (temp->line[59]=='\n')
	add=1;
      temp = temp->next;
    }

  if ((temp->next->line == NULL) && (strlen (temp->line) >= 59)) add = 1;
  
  while (temp->next->line != NULL)
    temp = temp->next;

  if (temp->number+add < 10) return (1); else return (0);
  
}

struct sum *del_char (struct sum *root, wm_handle win, int x, int y, int *last_x, int *last_y)
{

  int i,k;
  int over;			/* letzter Buchstabe der Zeile */
  struct sum *temp;

  temp = root;
  for (i=0; i<y; i++)
    temp = temp->next;

  if (temp->line[x] == '\n')	/* wenn Enter gelscht wird */
    {
				/* wird schon vorher abgefangen */
      
    } /* end wenn Enter gelscht wird */
  else				/* wenn sonstiges Zeichen gelscht wird */
    {
      k = strlen (temp->line);
      if (k>0) over = temp->line[k-1];
      else over = 0;
      for (i=x; i<k; i++)
	temp->line[i]=temp->line[i+1];

      if ((k==60) && (over != '\n') && (temp->next->line != NULL))
	{
	  while ((k == 60) && (over != '\n') && (temp->next->line != NULL))
	    {
	      temp = temp->next;
	      temp->prev->line[59]=temp->line[0];
	      temp->prev->line[60]='\x0';
	      wm_del_char (win, 0, temp->prev->number, 1);
	      wm_gotoxy (win, 0, temp->prev->number);
	      wm_printf (win, "%s", temp->prev->line);
	      k = strlen (temp->line);
	      if (k>0) over = temp->line[k-1];
	      else over = 0;
	      for (i=0; i<k; i++)
		temp->line[i]=temp->line[i+1];
	    }
	  if ((k==1) && (over == '\n'))	/* wenn einzelnes Enter gezogen wird */
	    {
	      temp->prev->line[59]='\n';
	      temp->prev->line[60]='\x0';
	      if (temp->number == (*last_y))
		{
		  del_line (root, (*last_y), last_x, last_y);
		  wm_del_line (win, (*last_y), 1);
		}
	      else
		{
		  del_line (root, temp->number, last_x, last_y);
		  wm_del_line (win, temp->number, 1);
		}
	    } /* end wenn einzelnes Enter gezogen wird */
	  else			/* wenn letzte Zeile erreicht */
	    {
	      if (temp->number == (*last_y))
		{
		  if (k==0)
		    {
		      del_line (root, temp->number, last_x, last_y);
		    }
		  else
		    {
		      wm_del_char (win, 0, (*last_y), 1);
		      (*last_x) = strlen (temp->line);
		    }
		}
	      else			/* wenn sonstige Enter-Zeile erreicht */
		{
		  wm_del_char (win, 0, temp->number, 1);
		}
	    }
	}
      else
	{
	  wm_gotoxy (win, 0, temp->number);
	  wm_del_char (win, x, y, 1);
	  if (temp->number == (*last_y)) (*last_x)--;
	}
      
    } /* end wenn sonstiges Zeichen gelscht wird */

  return (temp);
}


struct sum *del_line (struct sum *root, int y, int *last_x, int *last_y)
{

  int i;
  struct sum *temp;

  temp = root;
  for (i=0; i<y; i++)
    temp = temp->next;

  while (temp->number < (*last_y))
    {
      strcpy (temp->line, temp->next->line);
      temp = temp->next;
    }

  free ((void *)temp->line);
  free ((void *)temp->next);
  temp->line = NULL;
  temp->next = NULL;
  
  (*last_y)--;
  (*last_x) = strlen (temp->prev->line);
  
  temp = root;
  while ((temp->number != y) && (temp->number <= (*last_y)))
    temp = temp->next;

  return (temp);
    
}
