/* search.c */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <conio.h>
#include <sys/winmgr.h>
#include <sys/video.h>
#include <sys/kbdscan.h>
#include "global.h"

#define ALL 1
#define KEYWORDS 2
#define TITLE 3
#define AUTHOR 4
#define ISSUE 5

#define LENGTH 3

extern struct search_str *found;
extern struct search_str *found_root;
extern int date_file;
extern int idx_file;

int select_mode (char *words);
void search_all (int mode, char *words);
char *input_str (char *words);

void search (int purpose)
{

  int dummy;
  char *words;
  int mode=0;

  words = (char *)malloc (52);
  
  mode = select_mode (words);
  v_attrib (F_WHITE|B_BLACK);
    
  switch (mode)
    {
    case ALL:
      search_all (ALL, words);
      break;

    case KEYWORDS:
      search_all (KEYWORDS, words);
      break;

    case TITLE:
      search_all (TITLE, words);
      break;

    case AUTHOR:
      search_all (AUTHOR, words);
      break;

    case ISSUE:
      search_all (ISSUE, words);
      break;
      
    case 0:
      break;

    default:
      break;
    }

  if (found->page==0)
    {
      v_attrib (F_WHITE|B_BLACK);
      v_gotoxy (34,23);
      v_printf ("nothing found");
      v_attrib (F_YELLOW|B_BLUE);
      dummy = getch ();
      if (dummy==0) dummy = getch ();
    }
  else show_found (purpose);

  free ((void *)words);
}

void search_all (int mode, char *words)
{
  int rd;			/* Anzahl gelesener Bytes */
  struct index temp;
  int ok;
  long int dat,idx;
  long int offset;
  char author[100], authort[100];
  char title[200], titlet[200];
  char keywords[200], keywordst[200];
  char summary[600], summaryt[600];

  lseek (idx_file, 0, SEEK_SET);
  lseek (date_file, 0, SEEK_SET);

  idx = tell (idx_file);
  rd = read (idx_file, &temp, sizeof(temp));
  words = strupr (words);
  
  while (rd > 0)
    {
      dat = tell (date_file); 

      switch (mode)
	{
	case ALL:
	  read (date_file, &author, temp.author);
	  author[temp.author]=0;
	  strcpy (authort, author);
	  strupr (authort);
	  read (date_file, &title, temp.title);
	  title[temp.title]=0;
	  strcpy (titlet, title);
	  strupr (titlet);
	  read (date_file, &keywords, temp.keywords);
	  keywords[temp.keywords]=0;
	  strcpy (keywordst, keywords);
	  strupr (keywordst);
	  read (date_file, &summary, temp.summary);
	  summary[temp.summary]=0;
	  strcpy (summaryt, summary);
	  strupr (summaryt);
	  if ((strstr (authort, words) != NULL) || (strstr (titlet, words) != NULL) ||
	      (strstr (keywordst, words) != NULL) || (strstr (summaryt, words) != NULL))
	    ok = 1;
	  else ok = 0;
	  break;

	case AUTHOR:
	  read (date_file, &author, temp.author);
	  author[temp.author]=0;
	  strcpy (authort, author);
	  strupr (authort);
	  if (strstr (authort, words) != NULL)
	    {
	      ok = 1;
	      read (date_file, &title, temp.title);
	      title[temp.title]=0;
	      read (date_file, &keywords, temp.keywords);
	      keywords[temp.keywords]=0;
	      read (date_file, &summary, temp.summary);
	      summary[temp.summary]=0;
	    }
	  else
	    {
	      offset = temp.keywords+temp.summary+temp.title;
	      lseek (date_file, offset, SEEK_CUR);
	      ok = 0;
	    }
	  break;

	case TITLE:
	  offset = temp.author;
	  lseek (date_file, offset, SEEK_CUR);
	  read (date_file, &title, temp.title);
	  title[temp.title]=0;
	  strcpy (titlet, title);
	  strupr (titlet);
	  if (strstr (titlet, words) != NULL)
	    {
	      ok = 1;
	      offset = temp.title+temp.author;
	      lseek (date_file, 0-offset, SEEK_CUR);
	      read (date_file, &author, temp.author);
	      author[temp.author]=0;
	      lseek (date_file, temp.title, SEEK_CUR);
	      read (date_file, &keywords, temp.keywords);
	      keywords[temp.keywords]=0;
	      read (date_file, &summary, temp.summary);
	      summary[temp.summary]=0;	      
	    }
	  else
	    {
	      ok = 0;
	      offset = temp.keywords+temp.summary;
	      lseek (date_file, offset, SEEK_CUR);
	    }
	  break;

	case KEYWORDS:
	  offset = temp.title+temp.author;
	  lseek (date_file, offset, SEEK_CUR);
	  read (date_file, &keywords, temp.keywords);
	  keywords[temp.keywords]=0;
	  strcpy (keywordst, keywords);
	  strupr (keywordst);
	  if (strstr (keywordst, words) != NULL)
	    {
	      ok = 1;
	      offset = temp.title+temp.author+temp.keywords;
	      lseek (date_file, 0-offset, SEEK_CUR);
	      read (date_file, &author, temp.author);
	      author[temp.author]=0;
	      read (date_file, &title, temp.title);
	      title[temp.title]=0;
	      lseek (date_file, temp.keywords, SEEK_CUR);
	      read (date_file, &summary, temp.summary);
	      summary[temp.summary]=0;	      
	    }
	  else
	    {
	      ok = 0;
	      offset = temp.summary;
	      lseek (date_file, offset, SEEK_CUR);
	    }
	  break;	  

	case ISSUE:
	  if (strstr(temp.issue, words) != NULL)
	    {
	      ok = 1;
	      read (date_file, &author, temp.author);
	      author[temp.author]=0;
	      read (date_file, &title, temp.title);
	      title[temp.title]=0;
	      read (date_file, &keywords, temp.keywords);
	      keywords[temp.keywords]=0;
	      read (date_file, &summary, temp.summary);
	      summary[temp.summary]=0;
	    }
	  else
	    {
	      offset = temp.author+temp.title+temp.keywords+temp.summary;
	      lseek (date_file, offset, SEEK_CUR);
	      ok = 0;
	    }
	  break;	  
	  
	default:
	  ok = 0;
	  break;
	}
      
      if (ok)
	{
	  if (found->page != 0)
	    {
	      found->next = (struct search_str *)malloc (sizeof (struct search_str));
	      found->next->prev = found;
	      found = found->next;
	    }	  
	  found->next = NULL;
	  strcpy (found->issue, temp.issue);
	  found->idx = idx;	/* fr nderungen */
	  found->dat = dat;	/* fr nderungen */
	  found->page = temp.page;
	  found->author = (char *)malloc (temp.author+1);
	  found->keywords = (char *)malloc (temp.keywords+1);
	  found->title = (char *)malloc (temp.title+1);
	  found->summary = (char *)malloc (temp.summary+1);
	  strcpy (found->author, author);
	  strcpy (found->title, title);
	  strcpy (found->keywords, keywords);
	  strcpy (found->summary, summary);
	}

      idx = tell (idx_file);
      rd = read (idx_file, &temp, sizeof (temp));
    }
}


int select_mode (char *words)
{
  wm_handle win;
  int c;
  int x,y;
  char menu[6][15];

  strcpy (menu[1], "everything");
  strcpy (menu[2], "keyword");
  strcpy (menu[3], "title");
  strcpy (menu[4], "author");
  strcpy (menu[5], "issue");
    
  wm_init (2);
  win = wm_create (20,4,35,10,1,F_YELLOW|INTENSITY|B_BLUE,F_YELLOW|INTENSITY|B_BLUE);
  wm_border (win, 1, F_YELLOW|INTENSITY|B_BLUE, "search for", 0, F_YELLOW|INTENSITY|B_BLUE);
  wm_open (win);

  wm_gotoxy (win, 2, 1);
  wm_attrib (win, F_YELLOW|INTENSITY|B_WHITE);
  wm_puts (win, menu[1]);  
  wm_attrib (win, F_YELLOW|INTENSITY|B_BLUE);
  wm_gotoxy (win, 2, 2);
  wm_puts (win, menu[2]);
  wm_gotoxy (win, 2, 3);
  wm_puts (win, menu[3]);
  wm_gotoxy (win, 2, 4);
  wm_puts (win, menu[4]);
  wm_gotoxy (win, 2, 5);
  wm_puts (win, menu[5]);
  wm_gotoxy (win, 2, 1);	/* gehe zum default menu-eintrag */
  
  c = 0;
  while (c!=27)
    {
      c = getch ();
      if (c==0) {c=getch (); c+=256;}

      switch (c)
	{
	case K_DOWN+256:
	  wm_getxy (win, &x, &y);
	  if (y<5)
	    {
	      wm_attrib (win, F_YELLOW|INTENSITY|B_BLUE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	      y++;
	      wm_attrib (win, F_YELLOW|INTENSITY|B_WHITE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	    }
	  break;
	  
	case K_UP+256:
	  wm_getxy (win, &x, &y);
	  if (y>1)
	    {
	      wm_attrib (win, F_YELLOW|INTENSITY|B_BLUE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	      y--;
	      wm_attrib (win, F_YELLOW|INTENSITY|B_WHITE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	    }
	  break;
	  
	case 13:
	  wm_getxy (win, &x, &y);
	  words = input_str (words);
	  if (words[0] == '\x001') y=0;
	  
	  wm_close (win);
	  wm_exit ();
	  return (y);
	  break;
	}
    }

  wm_close (win);
  wm_exit ();
  return (0);
  
}


char *input_str (char *words)
{
  char temp[52];
  int x, y;
  wm_handle win;
  int c;
  int i, k;

  for (i=0; i<=51; i++)
    temp[i]=0;
  
  win = wm_create (15,13,69,14,1,F_YELLOW|INTENSITY|B_BLUE,F_YELLOW|INTENSITY|B_BLUE);
  wm_border (win, 1, F_YELLOW|INTENSITY|B_BLUE, "search for substring:", 0, F_YELLOW|INTENSITY|B_BLUE);
  wm_open (win);
  wm_cursor (win);
  wm_gotoxy (win, 0, 0);

  c = 0;
  
  while (c != 27)
    {
      c = getch ();
      if (c==0) {c = getch (); c+=256;}

      switch (c)
	{
	case K_LEFT+256:
	  wm_getxy (win, &x, &y);
	  if (x>0)
	    {
	      x--;
	      wm_gotoxy (win, x, y);
	    }
	  break;

	case K_RIGHT+256:
	  wm_getxy (win, &x, &y);
	  k = strlen (temp);
	  if ((x<50) && (k>0) && (x<k))
	    {
	      x++;
	      wm_gotoxy (win, x, y);
	    }
	  break;

	case K_DEL+256:
	  wm_getxy (win, &x, &y);
	  k = strlen (temp);
	  if ((k>0) && (x<k))
	    {
	      for (i=x; i<k; i++)
		temp[i]=temp[i+1];
	      wm_del_char (win, x, y, 1);
	    }
	  break;

	case 8:
	  wm_getxy (win, &x, &y);
	  k = strlen (temp);
	  if (x>0)
	    {
	      for (i=x-1; i<k; i++)
		temp[i]=temp[i+1];
	      wm_del_char (win, x-1, y, 1);
	      wm_gotoxy (win, x-1, y);
	    }
	  break;
	  
	case 13:
	  strcpy (words, temp);
	  wm_close (win);
	  return (words);
	  break;

	default:
	  wm_getxy (win, &x, &y);
	  k = strlen (temp);
	  if ((c>31) && (k<50))
	    {
	      for (i=k+1; i>=x; i--)
		temp[i+1]=temp[i];
	      temp[x]=c;
	      wm_ins_char (win, x, y, 1);
	      wm_putc_at (win, x, y, c);
	      wm_gotoxy (win, x+1, y);
	    }
	  break;
	  
	}
    }

  strcpy (words, "\x001\x0");	/* Pseudo-Null-Rckgabe */
  wm_close (win);
  return (words);
}
