/* spectrum.c */

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <conio.h>
#include <sys/winmgr.h>
#include <sys/video.h>
#include <sys/kbdscan.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "global.h"

int idx_file;
int date_file;
struct search_str *found;
struct search_str *found_root;

void init_found ();
int main_menu ();

void main (void)
{

  int selection;
  int dummy;

  date_file = open ("spectrum.dat", O_CREAT|O_BINARY|O_RDWR|O_APPEND, S_IREAD|S_IWRITE);
  idx_file = open ("spectrum.idx", O_CREAT|O_BINARY|O_RDWR|O_APPEND, S_IWRITE|S_IREAD);

  init_found ();
  
  v_init ();
  
  while (1)
    {

      v_attrib (F_WHITE|B_BLACK);
      v_scroll (0,0,80,24,24,V_SCROLL_UP);
      selection = main_menu ();

      switch (selection)
	{
	case INPUT:
	  input ();
	  break;

	case SEARCH:
	  search (FOUND);
	  break;

	case CHANGE:
	  search (CHANGE);
	  break;
	  
	case HELP:
 	  help (); 
	  break;

	case VERSION:
	  v_gotoxy (23,23);
	  v_printf ("spectrum database -- version 0.9");
	  dummy = getch ();
	  if (dummy == 0) dummy = getch ();
	  v_gotoxy (23,23);
	  v_clreol ();
	  break;
	  
	case QUIT:
	  close (idx_file);
	  close (date_file);
	  exit (0);
	}
    }
 
}

void init_found ()
{

  found = (struct search_str *)malloc (sizeof(struct search_str));
  found_root = found;
  found->next = NULL;
  found->prev = NULL;
  found->author = NULL;
  found->title = NULL;
  found->keywords = NULL;
  found->summary = NULL;
  strcpy (found->issue,"");
  found->page = 0;
  
}

int main_menu ()
{
  wm_handle win;
  int c, number;
  int x,y;
  char menu[7][20];

  strcpy (menu[1], "i - input entries");
  strcpy (menu[2], "c - change entry");
  strcpy (menu[3], "s - search entry");
  strcpy (menu[4], "v - version");
  strcpy (menu[5], "h - help");
  strcpy (menu[6], "q - quit");
    
  wm_init (1);
  win = wm_create (29,7,50,14,1,F_YELLOW|INTENSITY|B_BLUE,F_YELLOW|INTENSITY|B_BLUE);
  wm_border (win, 1, F_YELLOW|INTENSITY|B_BLUE, "main menu", 0, F_YELLOW|INTENSITY|B_BLUE);
  wm_open (win);

  wm_gotoxy (win, 2, 3);
  wm_attrib (win, F_YELLOW|INTENSITY|B_WHITE);
  wm_puts (win, menu[3]);  
  wm_attrib (win, F_YELLOW|INTENSITY|B_BLUE);
  wm_gotoxy (win, 2, 1);
  wm_puts (win, menu[1]);
  wm_gotoxy (win, 2, 2);
  wm_puts (win, menu[2]);
  wm_gotoxy (win, 2, 4);
  wm_puts (win, menu[4]);
  wm_gotoxy (win, 2, 5);
  wm_puts (win, menu[5]);
  wm_gotoxy (win, 2, 6);
  wm_puts (win, menu[6]);
  wm_gotoxy (win, 2, 3);	/* gehe zum default menu-eintrag */
  
  c = 0;
  while (c!='6')
    {
      c = getch ();
      if (c==0) {c=getch (); c+=256;}

      if ((c>='a') && (c<='z'))	/* wenn nummer gewhlt direkter return */
	{
	  wm_close (win);
	  wm_exit ();
	  if (c == 'i') number = 1;
	  if (c == 'c') number = 2;
	  if (c == 's') number = 3;
	  if (c == 'v') number = 4;
	  if (c == 'h') number = 5;
	  if (c == 'q') number = 6;
	  return (number);
	}
      
      switch (c)
	{
	case K_DOWN+256:
	  wm_getxy (win, &x, &y);
	  if (y<6)
	    {
	      wm_attrib (win, F_YELLOW|INTENSITY|B_BLUE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	      y++;
	      wm_attrib (win, F_YELLOW|INTENSITY|B_WHITE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	    }
	  break;
	  
	case K_UP+256:
	  wm_getxy (win, &x, &y);
	  if (y>1)
	    {
	      wm_attrib (win, F_YELLOW|INTENSITY|B_BLUE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	      y--;
	      wm_attrib (win, F_YELLOW|INTENSITY|B_WHITE);
	      wm_gotoxy (win, 2, y);
	      wm_puts (win, menu[y]);
	    }
	  break;
	  
	case 13:
	  wm_getxy (win, &x, &y);
	  wm_close (win);
	  wm_exit ();
	  return (y);
	  break;
	}
    }

  return (0);
}
